#
# Author: Seth Vargo <sethvargo@gmail.com>
#
# Copyright 2014 Chef Software, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

module Falcore
  class Aggregator
    attr_reader :config

    #
    #
    #
    def initialize(config)
      @config = config
    end

    def run
      hash = Fetcher.get("#{config.jenkins.endpoint}/computer/api/json")

      master = Node::Master.new(hash['computer'][0])
      slaves = hash['computer'][1..-1].map do |slave|
        Node::Slave.new(master, slave)
      end

      master
    end
  end
end
