#
# Author: Seth Vargo <sethvargo@gmail.com>
#
# Copyright 2014 Chef Software, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

module Falcore
  class Node::Master < Node::Base
    #
    # @param data (see Node::Base#initialize)
    #
    def initialize(data = {})
      super(data)
      @slaves = {}
    end

    #
    # @param [Node::Slave] slave
    #
    def add_slave(slave)
      unless slave.is_a?(Node::Slave)
        raise ArgumentError, "#{slave.class} is not an Falcore::Node::Slave"
      end

      @slaves[slave.id] = slave
      self
    end

    #
    # @return [Array<Node::Slave>]
    #
    def slaves
      @slaves.values
    end
  end
end
